'' Music Box
'' hacked from C3 SD Bootloader - by JT Cook
''
'' William Chan - www.huarobotics.com
''
'' Use keyboard or Parallax NES Adapter
'' Arrow Keys / Gamepad - select files
'' Enter, Spacebar - load an application
'' Gamepad A button, B button, or Start button - load an application
''
''  HISTORY
''  22/04/2011 v0.5 Can play one song
''  24/04/2011 v0.6 Can play any song!!
''  24/04/2011 v0.8 Reboots at end of song
''                  Play Indicators added
''  25/04/2011 v0.9 Press <Space> to stop song. Can select another song to play
''  28/04/2011 v1.0 Start Play Indicators earlier
''                  More responsive. Detects end of song earlier


CON

  PAL=%0001
  NTSC=%0000
  Hydra = 0
  Hybrid = 1
''Custom hardware configurations
'{ C3 setup
  _clkmode = xtal1 + pll16x    
  _xinfreq = 5_000_000         
  _memstart = $10      ' memory starts $10 in!!! (this took 2 headaches to figure out)  
  Key_Pins    = 26   ''pin location for keyboard
  Video_Pins = %001_0101   ''pin location for video out
  V_NP = NTSC ''video type - NTSC
  ''setup pin groupings for audio
  Audio_Pins = %00000001_00000000_00000000_00000000 '' 1 <<24
               '- CTR   PLL -------- BPIN   --- APIN  
  Audio_Ctra = %0_00110_000_00000000_000000_000_011000  ''APIN = 24
  Use_Key = 1 'set 1 because we want to use the keyboard and joypad
  Console = 0
  Audio_pin=24
  kilobyte= 1024
' }
  'where we start drawing the file names
  xStart = 1
  yMin = 4
  ''File description limits
  text_x = 11
  text_y = 4
 ''used for video driver
 SCANLINE_BUFFER = $7F00           
 request_scanline       = SCANLINE_BUFFER-4  'address of scanline buffer for TV driver
 tilemap_adr            = SCANLINE_BUFFER-8  'address of tile map
 tile_adr               = SCANLINE_BUFFER-12 'address of tiles
 border_color           = SCANLINE_BUFFER-16 'address of border color 
 sprite_adr             = SCANLINE_BUFFER-20  'address of where sprites are stored
 sprite_x_adr           = SCANLINE_BUFFER-24 'X location of 8 sprites
 sprite_y_adr           = SCANLINE_BUFFER-32 'Y location of 8 sprites
 sprite_number          = SCANLINE_BUFFER-40 'address of images of 8 sprites
 sprite_x_flip          = SCANLINE_BUFFER-48 'flag to flip sprite on x axis
 sprite_y_flip          = SCANLINE_BUFFER-49 'flag to flip sprite on y axis
 Font_offset = 14 ''where font starts
 Max_Tiles  = 134
 cursor_offset = 4 'start of cursor
   spiCnt    =  8                      ' SPI select count 0->1->0
   spiDI     =  9                      ' SPI MOSI (or DI)
   spiDO     = 10                      ' SPI MISO (or DO)
   spiClk    = 11                      ' SPI Clock 0->1->0
   spiSel    =  5                      ' SPI select for microSD card
   spiClr    = 25                      ' SPI select clear 1->0->1

    GP_RIGHT  = %00000001
    GP_LEFT   = %00000010
    GP_DOWN   = %00000100
    GP_UP     = %00001000
    GP_START  = %00010000
    GP_SELECT = %00100000
    GP_B      = %01000000
    GP_A      = %10000000

    font_color    = $06
'    font_bg_color = $02 'black
    font_bg_color = $FF '$1B '$43
    border_colr  = $06
    max_files = 20 'max number of files on screen
    max_mount_time = 30 'max amount of tries it will try to mount SD card

    AUDIO_MONO             = 24
       
OBJ
  tv_game_gfx : "JTC_Tile_Drv.spin"          ' JTC's Tile Driver
  fsrw : "db_c3_fsrwFemto"                   ' Modified SD routines
  gc   : "c3_gamepad_keyboard_v002a"
  wav  : "c3wavplay16stereo" 

  
VAR
   long Tile_Map_Adr ''address to tilemap for graphics driver
   long TV_Type  ''NTSC or PAL
   long joypad ''joy pad
   long joypadold ''old status of joypad
   byte tile_gfx[(64*Max_Tiles)] 'tile graphics space
   'sd card routines
     byte command[32]
     byte f0[32]
     byte tbuf[20] ' SD Vars
     long tp

  long buffer_size
  long flash_ptr
  byte numbertext[8]

  long ioControl[2]
  long ptr
  long gp
  long chr
  byte buffer[14]
  byte num[2]
  byte KeyVal
  byte strbuff[255]
  byte file_list[256*12] 'filename (8.3) for 0 x 256 (max entries)
  byte file_offset 'used for scrolling files
  byte file_numbers ' number of files
  byte cursor_pos
  
PUB start | n, fin               
  ''set up graphics driver
  ''NTSC or PAL
  TV_Type:=V_NP
  tv_game_gfx.start(Video_Pins,TV_Type) 'start graphics driver
  tv_game_gfx.Set_Border_Color(border_colr)'set border color
  
' Long[Tile_Adr]:=@TileFile 'grab address of tile graphics
  Long[Tile_Adr]:=@tile_gfx
  Tile_Map_Adr:=LONG[CONSTANT($7F00-8)] 'grab address of tile map

  repeat n from 0 to (64*Max_Tiles) 'tiles
    tile_gfx[n]:=$F2 'set a default color to black 
  ''copy 1 bit font to 8 bit tiles
  repeat n from 0 to (Max_Tiles-35) 
    tv_game_gfx.Convert_Tile(@Char_data, n+Font_Offset,n, font_bg_color, font_color)

   fin:=0
  repeat n from 0 to 192
    LONG[Tile_Map_Adr+fin]:=$0E_0E_0E_0E
    fin+=4  
  ''Draw upper title and columns
  Draw_Title
  joypadold:=$FFFF ''start out as holding down all buttons
  joypad:=$FFFF ''start out as holding down all buttons  
  ' start the game pad driver
  gc.start(26, 1) 'keyboard pin, enable keyboard
    
  fsrw.start(@ioControl)               'Start I2C/SPI driver  
  MountCard                            'run through SD Card mounting routines  
  Load_WavFile_List                    'list all wav files on root folder
  
  fin:=0
  file_offset:=0 'used for scrolling screen
  Load_Text(fin)
  Print_String(0,2,string("Number of Songs:"))
  Int_To_String(@numbertext, file_numbers)
  Print_String(17,2,@numbertext)          
  cursor_pos:=0    
  tv_game_gfx.Place_Tile_XY(0,cursor_pos+cursor_offset,CONSTANT(130+Font_offset-32))
  tv_game_gfx.Place_Tile_XY(9,cursor_pos+cursor_offset,CONSTANT(131+Font_offset-32))                            
  
  repeat
        joypad := gc.read_gamepad
        if(Check_Tap_Key(GP_START)==1 OR Check_Tap_Key(GP_B)==1 OR Check_Tap_Key(GP_A)==1)
              if Play_File(fin)      ' play the file
                 show_play_indicators
        if(Check_Tap_Key(GP_UP))
          if cursor_pos > 0
              tv_game_gfx.Place_Tile_XY(0,cursor_pos+cursor_offset,CONSTANT(32+Font_offset-32))
              tv_game_gfx.Place_Tile_XY(9,cursor_pos+cursor_offset,CONSTANT(32+Font_offset-32))                            
              cursor_pos--
              tv_game_gfx.Place_Tile_XY(0,cursor_pos+cursor_offset,CONSTANT(130+Font_offset-32))
              tv_game_gfx.Place_Tile_XY(9,cursor_pos+cursor_offset,CONSTANT(131+Font_offset-32))                            
              fin--
              Load_Text(fin)
          ''scroll list
          if (cursor_pos == 0 AND (fin>0))
              fin--
              file_offset--
              Draw_File(file_offset)
              Load_Text(fin)
        if(Check_Tap_Key(GP_DOWN))        
          if (cursor_pos < 19) AND (fin<file_numbers-1)
              tv_game_gfx.Place_Tile_XY(0,cursor_pos+cursor_offset,CONSTANT(32+Font_offset-32))
              tv_game_gfx.Place_Tile_XY(9,cursor_pos+cursor_offset,CONSTANT(32+Font_offset-32))
              cursor_pos++               
              tv_game_gfx.Place_Tile_XY(0,cursor_pos+cursor_offset,CONSTANT(130+Font_offset-32))
              tv_game_gfx.Place_Tile_XY(9,cursor_pos+cursor_offset,CONSTANT(131+Font_offset-32))                            
              fin++
              Load_Text(fin)
          ''scroll list
          if (cursor_pos == 19 AND (fin<file_numbers-1))
              fin++
              file_offset++
              Draw_File(file_offset)
              Load_Text(fin)
   joypadold:=joypad ''grab last hit key
   
PUB MountCard | fin, n, n2
  n2:=0
  repeat until n2 == 1
   fin:=0   
   Print_String(0,2,string("Mounting SD...                  "))  
   repeat n from 0 to max_mount_time
    fin:=  \fsrw.mount(spiSel,spiClr,spiCnt,spiDI,spiDO,spiClk) ' Attempt to mount SD card
    if fin>-1 'file found
     quit    
   if fin <0
     Print_String(0,2,string("No SD card found    "))
     repeat 
      joypadold:=joypad ''grab last hit key     
      joypad := gc.read_gamepad    
      if(Check_Tap_Key(GP_START)==1 OR Check_Tap_Key(GP_B)==1 OR Check_Tap_Key(GP_A)==1)
       quit
   else
    Print_String(0,2,string("                      "))
    n2:=1
    quit
                 

PUB Draw_Title  | n, fin
   Print_String(4,0,string("== C3 Music Box v1.0 =="))

  'draw borders
  repeat n from 0 to 31
    byte[Tile_Map_Adr+n+CONSTANT(32*3)]:=CONSTANT(127-18)
  fin:=CONSTANT((32*4)+10)
  repeat n from 4 to 23
    byte[Tile_Map_Adr+fin]:=127-18
    fin+=32   


PUB Int_To_String(adr, i) | t
' does an sprintf(str, "%05d", i); job
if i<10
 adr+=(1-1)
elseif i<100
 adr+=(2-1)
else
 adr+=(3-1)
BYTE[adr+1]:=0 
repeat t from 0 to 8
  BYTE[adr] := (i // 10) + 48
  i/=10
  adr--      

PUB Check_Tap_Key(key_hit)
  ''check joy pad 1
  if(key_hit<$0100)
   if(((joypad & key_hit & $00FF) & ((joypadold & key_hit & $00FF)^ key_hit)) <> 0)
    return 1
  ''check joy pad 2
  if(key_hit>$00FF)
   if(((joypad & key_hit & $FF00) & ((joypadold & key_hit & $FF00)^ key_hit)) <> 0)
    return 1
  else
    return 0

PUB Print_String(x,y,adr) | n, text_adr
'' prints a string
  n:=0
  text_adr:=adr
  repeat until byte[text_adr+n] == 0
    tv_game_gfx.Place_Tile_XY(x+n,y,byte[text_adr+n]+Font_offset-32) ''write character
    n++
    
PUB CopyFile(f_ptr, f_index) | n, findex
   'copies file into file index
   findex:=f_index*12
   'file_list[256*12] 'filename (8.3) for 0 x 256 (max entries)   
   repeat n from 0 to 11
      byte[@file_list+findex+n]:=byte[f_ptr+n] 'filename (8.3) x 256 (max entries)
      
PUB Load_Text (fin) | f_ptr, n, x,y, lf_13
'---Loads a text description of the file app
          lf_13:=0
          '--erase prior description
          repeat y from text_y to 23
            repeat x from text_x to 31
              tv_game_gfx.Place_Tile_XY(x,y,32+Font_offset-32)                       
          f_ptr:=fin*12
          repeat n from 0 to 11
           byte[@Buffer+n]:=byte[@file_list+f_ptr+n] 'filename (8.3) x 256 (max entries)
           if(byte[@Buffer+n]==46) 'look for period
            quit
          byte[@Buffer+(++n)]:="t"
          byte[@Buffer+(++n)]:="x"
          byte[@Buffer+(++n)]:="t"
          byte[@Buffer+(++n)]:=0 'terminate string
          if \fsrw.popen(@Buffer,"r")                           
            Print_String(text_x,text_y,string("Description File"))
            Print_String(text_x,text_y+1,@Buffer)
            Print_String(text_x,text_y+2,string("Not Found"))
'-----------draw the text descriptions          
          else
            x:=text_x
            y:=text_y
            repeat while n>0
              n := fsrw.pgetc
              if(n>31 AND n<128)
                'write characters to the screen
                if(x<32)
                 tv_game_gfx.Place_Tile_XY(x,y,n+Font_offset-32)
                x++
              ''handle both windows and unix line feeds
              if n== 13 OR (n==10 AND lf_13==0)'handle CR
                if(n==13) 'windows linefeeds will use both 13 and 10
                  lf_13:=1 'we only want one linefeed, so we will ignore if windows
                x:=text_x
                y++
                if y>23
                 n:=-1                                         


PUB Play_File(fin) | f_ptr, n
   'plays a wav file from file index
          'gc.stop   'stop keyboard driver
          f_ptr:=fin*12
          repeat n from 0 to 11
             byte[@Buffer+n]:=byte[@file_list+f_ptr+n] 'filename (8.3) x 256 (max entries)
          byte[@Buffer+12]:=0 'make sure we always terminate it
          fsrw.unmount
          fsrw.stop
          if wav.init_sdcard
             wav.play(@Buffer)
             return TRUE
          else
             return FALSE
      

PRI show_play_indicators | i, delta

     Print_String(0,2,string(" Playing           "))
     waitcnt(clkfreq + cnt) ' delay to prevent double press

     i := 8
     delta := 1
     repeat
        Print_String(i,2,string(" - "))
        waitcnt(clkfreq/10 + cnt)
        joypad := gc.read_gamepad
        if Check_Tap_Key(GP_B)==1
          stop_song
          return
        i := i + delta
        if i > 24
           delta := -1
        if i < 9
           delta := 1   
        if wav.song_ended
           fsrw.start(@ioControl)      'Start I2C/SPI driver  
           MountCard                   ' remount SD card
           Print_String(0,2,string("Song has ended            ")) 
           return          


PRI stop_song              

     wav.kill                    '  Stop song now
     fsrw.start(@ioControl)      ' Start I2C/SPI driver  
     MountCard                   ' remount SD card
     Print_String(0,2,string("Please select song        "))
                 
                                            
PUB Draw_File(file_start) | n,n2, file_ptr,y
  if(file_numbers>0) 'make sure there are files to list
    'if there are more files above, show an arrow up
    if(file_start>0)
       byte[Tile_Map_Adr+CONSTANT((32*4)+10)]:=128-18
    else
       byte[Tile_Map_Adr+CONSTANT((32*4)+10)]:=127-18              
    'if there are more files below, show an arrow down
    if(file_start+20<file_numbers)
       byte[Tile_Map_Adr+CONSTANT((32*23)+10)]:=129-18
    else
       byte[Tile_Map_Adr+CONSTANT((32*23)+10)]:=127-18              
  
    file_ptr:=file_start*12
    y:=4
    repeat n from 0 to 20
     if(file_start<file_numbers)
       byte[@Buffer+8]:=0 'make sure we always have a terminating character
       'copy file name from file list (we do not want the .bin)
       repeat n2 from 0 to 7
           byte[@Buffer+n2]:=byte[@file_list+file_ptr+n2] 'filename 8
           if(byte[@Buffer+n2]==46) 'look for period
              byte[@Buffer+n2]:=0 
            quit
       'erase prior file name
       Print_String(xStart,y,string("        "))            
       'print file name
       Print_String(xStart,y++,@Buffer)             
       file_start++
       file_ptr+=12
     ''no more files - just erase the remaining spaces
     else
       'erase prior file name
       Print_String(xStart,y++,string("        "))
       
PUB Load_WavFile_List | t

    file_numbers:=0
    if \fsrw.mount(spiSel,spiClr,spiCnt,spiDI,spiDO,spiClk) < 0  ' Attempt to mount SD card
      Print_String(0,2,string("No .WAV files found"))
      abort
    fsrw.opendir
    repeat while fsrw.nextfile(@ptr) == 0

      t:=StrRight(@ptr,3)
      if strcomp(t,string("WAV"))
          ''limit the number of files
         if(file_numbers<256)
          CopyFile(@ptr,file_numbers)
          file_numbers++
         else
           quit
    Draw_File(0)
     
PUB StrRight(str,len) | i,l,z

  l:=strSize(str)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[@ptr][i]
    z++
  return @strbuff

  
DAT
 ''sprite graphics
'SpriteFile file "sprite.spr"
 ''tile graphics
'TileFile file "font.til"

Char_data
'enter, special characters
byte 0,0,0,0,0,0,0,0 ' Enter/Clear - 32              
byte 24,24,24,24,0,0,24,0 ' ! - 33
byte 102,102,102,0,0,0,0,0 ' " - 34
byte 102,102,255,102,255,102,102,0 ' # - 35
byte 24,62,96,60,6,124,24,0 '$ - 36
byte 98,102,12,24,48,102,70,0' % - 37
byte 60,102,60,56,103,102,63,0 ' & - 38
byte 6,12,24,0,0,0,0,0 ' ' - 39              
byte 12,24,48,48,48,24,12,0 ' ( - 40
byte 48,24,12,12,12,24,48,0 ' ) - 41
byte 0,102,60,255,60,102,0,0 ' * - 42
byte 0, 24,24,126,24,24,0,0 ' +  - 43
byte 0,0,0,0,0,24,24,48 ' ,  44
byte 0,0,0,126,0,0,0,0 ' - - 45
byte 0,0,0,0,0,24,24,0 ' . - 46              
byte 0,3,6,12,24,48,96,0 ' / - 47
'Numbers 0-9
byte 60,102,110,118,102,102,60,0 ' 0 - 48
byte 24,24,56,24,24,24,126,0 ' 1 - 49
byte 60,102,6,12,48,96,126,0 ' 2 - 50
byte 60,102,6,28,6,102,60,0 ' 3 - 51
byte 6,14,22,102,127,6,6,0 ' 4 - 52
byte 126,96,124,6,6,102,60,0 ' 5 - 53              
byte 60,102,96,124,102,102,60,0 ' 6 - 54
byte 126,102,12,12,12,12,12,0 ' 7 - 55
byte 60,102,102,60,102,102,60,0 ' 8 - 56
byte 60,102,102,62,6,102,60,0 ' 9 - 57
'special characters
byte 0,0,24,0,0,24,0,0 ' : - 58
byte 0,0,24,0,0,24,24,48 ' ; - 59
byte 14,24,48,96,48,24,14,0 ' < - 60
byte 0,0,126,0,126,0,0,0 ' = - 61
byte 112,24,12,6,12,24,112,0 ' > - 62
byte 60,102,6,12,24,0,24,0 ' ? - 63
byte 60,102,110,110,96,98,60,0 ' @ - 64
'A-Z upper case
byte 24,60,102,126,102,102,102,0 ' A - 65
byte 124,102,102,124,102,102,124,0 ' B - 66
byte 60,102,96,96,96,102,60,0 ' C - 67
byte 120,108,102,102,102,108,120,0 ' D - 68
byte 126,96,96,120,96,96,126,0 ' E - 69
byte 126,96,96,120,96,96,96,0 ' F - 70
byte 60,102,96,110,102,102,60,0 ' G - 71
byte 102,102,102,126,102,102,102,0 ' H - 72
byte 60,24,24,24,24,24,60,0 'I - 73
byte 30,12,12,12,12,108,56,0 ' J - 74
byte 102,108,120,112,120,108,102,0 ' K - 75
byte 96,96,96,96,96,96,126,0 ' L - 76
byte 99,119,127,107,99,99,99,0 ' M - 77
byte 102,118,126,110,102,102,102,0 ' N - 78
byte 60,102,102,102,102,102,60,0 ' O - 79
byte 124,102,102,124,96,96,96,0 ' P - 80
byte 60,102,102,102,102,102,60,14 ' Q - 81
byte 124,102,102,124,120,108,102,0 ' R - 82
byte 60,102,96,60,6,102,60,0 ' S - 83
byte 126,24,24,24,24,24,24,0 ' T - 84
byte 102,102,102,102,102,102,60,0 ' U - 85
byte 102,102,102,102,102,60,24,0 ' V - 86
byte 99,99,99,107,127,119,99,0 ' W - 87
byte 102,102,60,24,60,102,102,0 ' X - 88
byte 102,102,102,60,24,24,24,0 ' Y - 89
byte 126,6,12,24,48,112,126,0 ' Z - 90
'special characters
byte 60,48,48,48,48,48,60,0 ' [ - 91
byte 0,96,48,24,12,6,3,0 ' \ - 92
byte 60,12,12,12,12,12,60,0 ' ] - 93
byte 24,60,102,0,0,0,0,0 ' ^ - 94
byte 0,0,0,0,0,0,255,0 ' _ - 95
byte 96,48,24,0,0,0,0,0 ' ` - 96
'a-z lower case
byte 0,0,60,6,62,102,62,0 'a - 97
byte 0,96,96,124,102,102,124,0 ' b - 98
byte 0,0,60,96,96,96,60,0 ' c - 99
byte 0,6,6,62,102,102,62,0 ' d - 100
byte 0,0,60,102,126,96,60,0 ' e - 101
byte 0,14,24,62,24,24,24,0 ' f - 102
byte 0,0,62,102,102,62,6,124 ' g - 103
byte 0,96,96,124,102,102,102,0 ' h - 104
byte 0,24,0,56,24,24,60,0 ' i -105
byte 0,6,0,6,6,6,6,60 ' j -106
byte 0,96,96,108,120,108,102,0 ' k - 107
byte 0,56,24,24,24,24,60,0 ' l - 108
byte 0,0,102,127,127,107,99,0 ' m - 109
byte 0,0,124,102,102,102,102,0 ' n - 110
byte 0,0,60,102,102,102,60,0 ' o - 111
byte 0,0,124,102,102,124,96,96 ' p - 112
byte 0,0,62,102,102,62,6,6 ' q - 113
byte 0,0,124,102,96,96,96,0 ' r - 114
byte 0,0,62,96,60,6,124,0 ' s - 115
byte 0,24,126,24,24,24,14,0 ' t - 116
byte 0,0,102,102,102,102,62,0 ' u - 117
byte 0,0,102,102,102,60,24,0 ' v - 118
byte 0,0,99,107,127,62,54,0 ' w - 119
byte 0,0,102,60,24,60,102,0 ' x - 120
byte 0,0,102,102,102,62,12,120' y - 121
byte 0,0,126,12,24,48,126,0 ' z - 122
byte 28,48,48,224,48,48,28,0 ' { - 123
byte 24,24,24,24,24,24,24,24 ' | - 124
byte 56,12,12,7,12,12,56,0 ' } - 125
byte 54,108,0,0,0,0,0,0 ' ~ - 126
byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF 'full block - 127
byte 239,199,131,1,1,199,199,255 'up arrow - 128
byte 199,199,1,1,131,199,239,255 'down arrow -129
byte 48,56,252,254,252,56,48,0 'right arrow - 130
byte 12,28,63,127,63,28,12,0 ' left arrow - 131